diff --git a/src/backend/access/nbtree/nbtinsert.c b/src/backend/access/nbtree/nbtinsert.c
index 1c1d4a4bc9..c2b587e099 100644
--- a/src/backend/access/nbtree/nbtinsert.c
+++ b/src/backend/access/nbtree/nbtinsert.c
@@ -1289,7 +1289,6 @@ _bt_insertonpg(Relation rel,
 			xl_btree_metadata xlmeta;
 			uint8		xlinfo;
 			XLogRecPtr	recptr;
-			uint16		upostingoff;
 
 			xlrec.offnum = newitemoff;
 
@@ -1340,13 +1339,15 @@ _bt_insertonpg(Relation rel,
 			}
 
 			XLogRegisterBuffer(0, buf, REGBUF_STANDARD);
-			if (postingoff == 0)
+			if (postingoff <= 0)
 			{
 				/* Just log itup from caller */
 				XLogRegisterBufData(0, (char *) itup, IndexTupleSize(itup));
 			}
 			else
 			{
+				uint16		upostingoff;
+
 				/*
 				 * Insert with posting list split (XLOG_BTREE_INSERT_POST
 				 * record) case.